"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => useLaze
});

// src/useLaze.ts
var import_react_hooks = require("@lyonph/react-hooks");
var import_react = require("react");
function useLaze(options) {
  const [visible, setVisible] = (0, import_react.useState)(false);
  const ref = (0, import_react_hooks.useReactiveRef)(() => null);
  const { current } = ref;
  const refreshRef = (0, import_react_hooks.useFreshLazyRef)(() => options == null ? void 0 : options.refresh, options == null ? void 0 : options.refresh);
  (0, import_react.useEffect)(() => {
    setVisible(false);
    if (current) {
      const observer = new IntersectionObserver((entries) => {
        entries.forEach((entry) => {
          if (entry.target === current) {
            if (refreshRef.current) {
              setVisible(entry.isIntersecting);
            } else if (entry.isIntersecting) {
              setVisible(true);
              observer.disconnect();
            }
          }
        });
      });
      observer.observe(current);
      return () => {
        observer.unobserve(current);
        observer.disconnect();
      };
    }
    return void 0;
  }, [current, refreshRef]);
  const value = {
    ref,
    visible
  };
  (0, import_react.useDebugValue)(value);
  return value;
}
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
